#ifndef KRIMI_DINNER_ENGINE_ASSETMANAGER_H
#define KRIMI_DINNER_ENGINE_ASSETMANAGER_H

#include "Texture.h"
#include "Renderer.h"

struct AAssetManager;

struct FileBuffer
{
    const void* data;
    size_t size;

    void* internal;
};

class AssetManager {
public:
    static AssetManager* ptr;

    static void create(AAssetManager* android_asset_manager);

    bool loadFile(const char* path, FileBuffer* p_file_buffer);

    bool loadTexture(const char* path, Texture* p_texture);

    void releaseFileBuffer(FileBuffer& fb);

private:
    AssetManager();
    ~AssetManager();

    AssetManager(const AssetManager&) = delete;
    AssetManager& operator=(const AssetManager&) = delete;

    AAssetManager* m_asset_mgr;
};


#endif
