#ifndef KRIMI_DINNER_ENGINE_STRINGREPOSITORY_H
#define KRIMI_DINNER_ENGINE_STRINGREPOSITORY_H

#include <stdint.h>
#include "Hash.h"

using StringHandle = uint32_t;

// Alias for compatibility
using nt_string_handle = StringHandle;

class StringRepository
{
public:
    // The default string repository
    static StringRepository* global;

    StringRepository() = default;
    StringRepository(const StringRepository& copy);
    ~StringRepository();

    StringHandle internStringLength(const char* string, unsigned int length);

    StringHandle internString(const char* string);

    const char* getString(StringHandle handle);

    void releaseString(StringHandle handle);

    void freeAll();

private:
    uint32_t m_buffer_size;
    uint32_t m_one_past_last_char;
    char* m_buffer;
    Hash m_hash;
};

#endif